#define OPTIMIZE_ROM_CALLS
#define RETURN_VALUE
#define MIN_AMS 101

#include <tigcclib.h>
typedef unsigned long long VLI;	//very long integer

VLI GCD(VLI m, VLI n)
{
	VLI tmp;
	while(m)
	{
		tmp = m;
		m = n % m;
		n = tmp;
	}       
	return n;
}

VLI ceiling(VLI num, VLI denom)
{
	return num % denom == 0 ? num/denom : num/denom + 1;
}

void _main(void)
{
	//Initialize argument pointer
	ESI q = top_estack;
	
	//Seperate the numerator (a) and denominator (b) from the passed argument
	//This both (1) simplifies the fraction and (2) makes sure that the denominator is neither zero nor one
	VLI a = GetIntArg(q);
	q++;
	VLI b = GetIntArg(q);
	
	//Ensure fraction is valid
	if(b==0)
	{
		ST_helpMsg("Input must be a non-integer fraction.");
		push_quantum(NOTHING_TAG);
		return;
	}
	
	//Remove whole numbers
	VLI w = a/b;
	push_longlongint(w);
	ESI ans;	//Answer variable
	a -= b*w;

	while(a != 0)
	{
		//Method 1 (forwards, ascending denominators)
		/*ans = top_estack;
		VLI n = ceiling(b,a);
		push_shortint(1);
		push_longlongint(n);
		push_quantum(DIV_TAG);
		push_expr_quantum(ans, ADD_TAG);*/
		
		//Method 2 (backwards, descending denominators)
		ans = top_estack;
		VLI n = ceiling(b,a);
		push_expression(ans);
		push_shortint(1);
		push_longlongint(n);
		push_quantum_pair(DIV_TAG, ADD_TAG);
		
		a = a*n-b;
		b *= n;
		VLI g=GCD(a,b);
		a /= g;
		b /= g;
	}
}
